/*********************************************************************
*                                                                    *
*                SEGGER Microcontroller GmbH & Co. KG                *
*        Solutions for real time microcontroller applications        *
*                                                                    *
**********************************************************************
*                                                                    *
* C-file generated by:                                               *
*                                                                    *
*        GUI_Builder for emWin version 5.28                          *
*        Compiled Jan 30 2015, 16:41:06                              *
*        (c) 2015 Segger Microcontroller GmbH & Co. KG               *
*                                                                    *
**********************************************************************
*                                                                    *
*        Internet: www.segger.com  Support: support@segger.com       *
*                                                                    *
**********************************************************************
*/

// USER START (Optionally insert additional includes)
#include "main.h"
#include "FRAMEWIN.h"
#include "TEXT.h"
#include "BUTTON.h"
#include "WM.h"

#include "Screen1DLG.h"
// USER END

#include "DIALOG.h"

/*********************************************************************
*
*       Defines
*
**********************************************************************
*/
#define ID_WINDOW_0 (GUI_ID_USER + 0x00)
#define ID_BUTTON_0 (GUI_ID_USER + 0x01)
#define ID_BUTTON_1 (GUI_ID_USER + 0x02)
#define ID_BUTTON_2 (GUI_ID_USER + 0x03)
#define ID_BUTTON_3 (GUI_ID_USER + 0x04)
#define ID_BUTTON_4 (GUI_ID_USER + 0x05)
#define ID_TEXT_0 (GUI_ID_USER + 0x06)
#define ID_TEXT_1 (GUI_ID_USER + 0x07)
#define ID_TEXT_2 (GUI_ID_USER + 0x08)
#define ID_TEXT_3 (GUI_ID_USER + 0x09)
#define ID_TEXT_4 (GUI_ID_USER + 0x0A)
#define ID_BUTTON_5 (GUI_ID_USER + 0x0B)


// USER START (Optionally insert additional defines)

#define SCN1_ID_POWER      ID_BUTTON_0
#define SCN1_ID_LIGHT      ID_BUTTON_1
#define SCN1_ID_MAIL       ID_BUTTON_2
#define SCN1_ID_HOME       ID_BUTTON_3
#define SCN1_ID_LANGUAGE   ID_BUTTON_4
#define SCN1_ID_TEXT_APP_NAME	ID_TEXT_0
#define SCN1_ID_TEXT_MAIL  		ID_TEXT_1
#define SCN1_ID_TEXT_HOME 		ID_TEXT_2
#define SCN1_ID_TEXT_LIGHT 		ID_TEXT_3
#define SCN1_ID_TEXT_TIME 		ID_TEXT_4
// USER END

/*********************************************************************
*
*       Static data
*
**********************************************************************
*/

// USER START (Optionally insert additional static data)
#ifdef STEP_4
/*background image*/
extern GUI_CONST_STORAGE GUI_BITMAP bmbackground;
/*board image*/
extern GUI_CONST_STORAGE GUI_BITMAP bmboard;
/*bulf off image*/
extern GUI_CONST_STORAGE GUI_BITMAP bmbulb_off;
/*bulf on image*/
extern GUI_CONST_STORAGE GUI_BITMAP bmbulb_on;
/*en flag image*/
extern GUI_CONST_STORAGE GUI_BITMAP bmUK;
/*fr flag image*/
extern GUI_CONST_STORAGE GUI_BITMAP bmFR;
/*power image*/
extern GUI_CONST_STORAGE GUI_BITMAP bmpower;
/*mail image*/
extern GUI_CONST_STORAGE GUI_BITMAP bmmail;
/*home image*/
extern GUI_CONST_STORAGE GUI_BITMAP bmhome;
/*light image*/
extern GUI_CONST_STORAGE GUI_BITMAP bmlight;
#endif

#ifdef STEP_5
static uint8_t onoff = 0; /*contain information if the bulb is on or off*/
#endif

#ifdef STEP_6
static uint8_t enfr = 0; /*contain information if language is en or fr*/
#endif

#ifdef STEP_8
/*font arial 24*/
extern GUI_CONST_STORAGE GUI_FONT GUI_FontArialNarrow24;
/*font arial 30*/
extern GUI_CONST_STORAGE GUI_FONT GUI_FontArialNarrow30;
#endif

#ifdef STEP_10
static uint8_t time_buffer[10]; /*buffer for time string*/
#endif
// USER END

/*********************************************************************
*
*       _aDialogCreate
*/
static const GUI_WIDGET_CREATE_INFO _aDialogCreate[] = {
  { WINDOW_CreateIndirect, "Screen1", ID_WINDOW_0, 0, 0, 480, 272, 0, 0x0, 0 },
  { BUTTON_CreateIndirect, "power", ID_BUTTON_0, 208, 95, 64, 64, 0, 0x0, 0 },
  { BUTTON_CreateIndirect, "light", ID_BUTTON_1, 127, 212, 41, 36, 0, 0x0, 0 },
  { BUTTON_CreateIndirect, "home", ID_BUTTON_2, 204, 212, 41, 36, 0, 0x0, 0 },
  { BUTTON_CreateIndirect, "mail", ID_BUTTON_3, 280, 213, 41, 36, 0, 0x0, 0 },
  { BUTTON_CreateIndirect, "language", ID_BUTTON_4, 430, 0, 40, 40, 0, 0x0, 0 },
  { TEXT_CreateIndirect, "Light Control", ID_TEXT_0, 15, 7, 320, 40, 0, 0x0, 0 },
  { TEXT_CreateIndirect, "MAIL", ID_TEXT_1, 283, 251, 64, 12, 0, 0x0, 0 },
  { TEXT_CreateIndirect, "HOME", ID_TEXT_2, 207, 251, 64, 12, 0, 0x0, 0 },
  { TEXT_CreateIndirect, "LIGHT", ID_TEXT_3, 130, 251, 50, 20, 0, 0x0, 0 },
  { TEXT_CreateIndirect, "XX:XX", ID_TEXT_4, 375, 7, 80, 20, 0, 0x0, 0 },
  { BUTTON_CreateIndirect, "Button", ID_BUTTON_5, 50, 93, 80, 20, 0, 0x0, 0 },
  // USER START (Optionally insert additional widgets)
  // USER END
};

/*********************************************************************
*
*       Static code
*
**********************************************************************
*/

// USER START (Optionally insert additional static code)
#ifdef STEP_6
/*power button callback*/
static void _cbPower(WM_MESSAGE * pMsg)
{
	/*decode message type*/
	switch (pMsg->MsgId)
	{
	/*component initialization message*/
	case WM_INIT_DIALOG:
		break;
		/*component repaint message*/
	case WM_PAINT:
		GUI_DrawBitmap(&bmpower, 8, 8);/*draw power button*/
		break;
		/*default callback message*/
	default:
		BUTTON_Callback(pMsg);
	}
}
#endif

#ifdef STEP_6
/*light button callback*/
static void _cbLight(WM_MESSAGE * pMsg)
{
	/*decode message type*/
	switch (pMsg->MsgId)
	{
	/*component initialization message*/
	case WM_INIT_DIALOG:

		break;
		/*component repaint message*/
	case WM_PAINT:
		GUI_DrawBitmap(&bmlight, 0, 0);/*draw light button*/
		break;
		/*default callback message*/
	default:
		BUTTON_Callback(pMsg);
	}
}
#endif

#ifdef STEP_6
/*mail button callback*/
static void _cbMail(WM_MESSAGE * pMsg)
{

	switch (pMsg->MsgId)
	{
	/*component initialization message*/
	case WM_INIT_DIALOG:
		break;
		/*component repaint message*/
	case WM_PAINT:
		GUI_DrawBitmap(&bmmail, 0, 0);/*draw mail button*/
		break;
		/*default callback message*/
	default:
		BUTTON_Callback(pMsg);
	}
}
#endif

#ifdef STEP_6
/*home button callback*/
static void _cbHome(WM_MESSAGE * pMsg)
{
	/*decode message type*/
	switch (pMsg->MsgId)
	{
	/*component initialization message*/
	case WM_INIT_DIALOG:
		break;
		/*component repaint message*/
	case WM_PAINT:
		GUI_DrawBitmap(&bmhome, 0, 0);/*draw home button*/
		break;
		/*default callback message*/
	default:
		BUTTON_Callback(pMsg);
	}
}
#endif

#ifdef STEP_6
/*language button callback*/
static void _cbLanguage(WM_MESSAGE * pMsg)
{
	/*decode message type*/
	switch (pMsg->MsgId)
	{
	/*component initialization message*/
	case WM_INIT_DIALOG:
		break;
		/*component repaint message*/
	case WM_PAINT:
		if (enfr)
		{
			GUI_DrawBitmap(&bmUK, 13, 7);/*draw uk lanbuage button*/
		}
		else
		{
			GUI_DrawBitmap(&bmFR, 13, 7);/*draw fr language button*/
		}
		break;
		/*default callback message*/
	default:
		BUTTON_Callback(pMsg);
	}
}
#endif
// USER END

/*********************************************************************
*
*       _cbDialog
*/
static void _cbDialog(WM_MESSAGE * pMsg) {
  int NCode;
  int Id;
  // USER START (Optionally insert additional variables)
#ifdef STEP_6
  WM_HWIN hItem;
#endif
  // USER END

  switch (pMsg->MsgId) {
  case WM_NOTIFY_PARENT:
    Id    = WM_GetId(pMsg->hWinSrc);
    NCode = pMsg->Data.v;
    switch(Id) {
    case ID_BUTTON_0: // Notifications sent by 'power'
      switch(NCode) {
      case WM_NOTIFICATION_CLICKED:
        // USER START (Optionally insert code for reacting on notification message)
#ifdef STEP_7
    	  /*check if the bulb is on or off*/
    	  if (onoff == 0)
    	  {
    		  onoff = 1;/*set bulb on*/
    	  }
    	  else
    	  {
    		  onoff = 0;/*set bulb off*/
    	  }
    	  hItem = WM_GetParent(pMsg->hWinSrc);/*get a handle of parent component(background window)*/
    	  WM_Invalidate(hItem);/*Force the parent window to repaint*/
#endif
        // USER END
        break;
      case WM_NOTIFICATION_RELEASED:
        // USER START (Optionally insert code for reacting on notification message)
        // USER END
        break;
      // USER START (Optionally insert additional code for further notification handling)
      // USER END
      }
      break;
    case ID_BUTTON_1: // Notifications sent by 'light'
      switch(NCode) {
      case WM_NOTIFICATION_CLICKED:
        // USER START (Optionally insert code for reacting on notification message)
        // USER END
        break;
      case WM_NOTIFICATION_RELEASED:
        // USER START (Optionally insert code for reacting on notification message)
        // USER END
        break;
      // USER START (Optionally insert additional code for further notification handling)
      // USER END
      }
      break;
    case ID_BUTTON_2: // Notifications sent by 'home'
      switch(NCode) {
      case WM_NOTIFICATION_CLICKED:
        // USER START (Optionally insert code for reacting on notification message)
        // USER END
        break;
      case WM_NOTIFICATION_RELEASED:
        // USER START (Optionally insert code for reacting on notification message)
        // USER END
        break;
      // USER START (Optionally insert additional code for further notification handling)
      // USER END
      }
      break;
    case ID_BUTTON_3: // Notifications sent by 'mail'
      switch(NCode) {
      case WM_NOTIFICATION_CLICKED:
        // USER START (Optionally insert code for reacting on notification message)
        // USER END
        break;
      case WM_NOTIFICATION_RELEASED:
        // USER START (Optionally insert code for reacting on notification message)
        // USER END
        break;
      // USER START (Optionally insert additional code for further notification handling)
      // USER END
      }
      break;
    case ID_BUTTON_4: // Notifications sent by 'language'
      switch(NCode) {
      case WM_NOTIFICATION_CLICKED:
        // USER START (Optionally insert code for reacting on notification message)
#ifdef STEP_7
    	  /*chack if active language is fr or uk*/
    	  if (enfr == 0)
    	  {
    		  enfr = 1;/*set language as uk*/
    	  }
    	  else
    	  {
    		  enfr = 0;/*set language to fr*/
    	  }
    	  hItem = WM_GetParent(pMsg->hWin);/*get a handle of parent component(button itself)*/
    	  WM_Invalidate(hItem);/*Force the parent window to repaint*/
#endif
        // USER END
        break;
      case WM_NOTIFICATION_RELEASED:
        // USER START (Optionally insert code for reacting on notification message)
        // USER END
        break;
      // USER START (Optionally insert additional code for further notification handling)
      // USER END
      }
      break;
    case ID_BUTTON_5: // Notifications sent by 'Button'
      switch(NCode) {
      case WM_NOTIFICATION_CLICKED:
        // USER START (Optionally insert code for reacting on notification message)
        // USER END
        break;
      case WM_NOTIFICATION_RELEASED:
        // USER START (Optionally insert code for reacting on notification message)
        // USER END
        break;
      // USER START (Optionally insert additional code for further notification handling)
      // USER END
      }
      break;
    // USER START (Optionally insert additional code for further Ids)
    // USER END
    }
    break;
  // USER START (Optionally insert additional message handling)
#ifdef STEP_5
    case WM_PAINT:
    	GUI_DrawBitmap(&bmbackground, 0, 0);/*draw background*/
    	GUI_DrawBitmap(&bmboard, -7, 64);/*draw board*/

    	/*check  if the bulb will be drawn as on or off*/
    	if (onoff == 1)
    	{
    		GUI_DrawBitmap(&bmbulb_on, 329, 74);/*draw bulb_on*/
    	}
    	else
    	{
    		GUI_DrawBitmap(&bmbulb_off, 329, 74);/*draw bulb_off*/
    	}

    	GUI_SetAlpha(191);/*set transparency 75% = 255(100%)-64(25%)*/
    	GUI_SetColor(GUI_BLACK);/*set pen colour to black*/
    	GUI_FillRect(0, 223, 480, 272);/*draw rectangle for the bottom buttons*/
    	GUI_FillRect(207, 95, 271, 159);/*draw rectangle for power button*/
    	GUI_SetAlpha(0);/*no transparency*/
    break;
#endif
    case WM_INIT_DIALOG:
#ifdef STEP_6
    	/*component initialization message*/
    	hItem = WM_GetDialogItem(pMsg->hWin, SCN1_ID_POWER);/*get a handle of power button*/
    	WM_SetCallback(hItem, _cbPower);/*create a callback for power button*/

    	hItem = WM_GetDialogItem(pMsg->hWin, SCN1_ID_LIGHT);/*get a handle of light button*/
    	WM_SetCallback(hItem, _cbLight);/*create a callback for light button*/

    	hItem = WM_GetDialogItem(pMsg->hWin, SCN1_ID_MAIL);/*get a handle of mail button*/
    	WM_SetCallback(hItem, _cbMail);

    	hItem = WM_GetDialogItem(pMsg->hWin, SCN1_ID_HOME);/*get a handle of home button*/
    	WM_SetCallback(hItem, _cbHome);/*create a callback for home button*/

    	hItem = WM_GetDialogItem(pMsg->hWin, SCN1_ID_LANGUAGE);/*get a handle of language button*/
    	WM_SetCallback(hItem, _cbLanguage);/*create a callback for language button*/
#endif
#ifdef STEP_9
    	hItem = WM_GetDialogItem(pMsg->hWin, SCN1_ID_TEXT_APP_NAME);/*get a handle of main label*/
    	TEXT_SetTextColor(hItem, 0xFFFFFF);/*set colour of main label */
    	TEXT_SetFont(hItem, &GUI_FontArialNarrow30);/*set font of main label*/

    	hItem = WM_GetDialogItem(pMsg->hWin, SCN1_ID_TEXT_MAIL);/*get a handle of mail label*/
    	TEXT_SetTextColor(hItem, 0x8B8D8B);/*set colour of mail label*/

    	hItem = WM_GetDialogItem(pMsg->hWin, SCN1_ID_TEXT_HOME);/*get a handle of home label*/
    	TEXT_SetTextColor(hItem, 0x8B8D8B);/*set colour of home label*/

    	hItem = WM_GetDialogItem(pMsg->hWin, SCN1_ID_TEXT_LIGHT);/*get a handle of light label*/
    	TEXT_SetTextColor(hItem, 0x8B8D8B);/*set colour of light label*/

    	hItem = WM_GetDialogItem(pMsg->hWin, SCN1_ID_TEXT_TIME);/*get a handle of time label*/
    	TEXT_SetTextColor(hItem, 0xCDAAAC);/*set colour of time label*/
    	TEXT_SetFont(hItem, &GUI_FontArialNarrow24);/*set font of time label*/
#endif
    break;
  // USER END
  default:
    WM_DefaultProc(pMsg);
    break;
  }
}

/*********************************************************************
*
*       Public code
*
**********************************************************************
*/
/*********************************************************************
*
*       CreateScreen1
*/
WM_HWIN CreateScreen1(void);
WM_HWIN CreateScreen1(void) {
  WM_HWIN hWin;

  hWin = GUI_CreateDialogBox(_aDialogCreate, GUI_COUNTOF(_aDialogCreate), _cbDialog, WM_HBKWIN, 0, 0);
  return hWin;
}

// USER START (Optionally insert additional public code)
#ifdef STEP_10
void UpdateTimeScreen1(WM_HWIN aDlgScreen, uint8_t aHour, uint8_t aMinute) {
	WM_HWIN hItem;

	hItem = WM_GetDialogItem(aDlgScreen, SCN1_ID_TEXT_TIME);/*get the time label handle*/
	sprintf((char*)time_buffer, "%02d:%02d", aHour, aMinute);/*convert the minute and hour to string buffer*/
	TEXT_SetText(hItem, (char*)time_buffer);/*set new text for the time label*/

	WM_InvalidateWindow(hItem);/*force the label to be repainted*/

	return;
}
#endif

// USER END

/*************************** End of file ****************************/
